#ifndef __LEVEL_H__
#define __LEVEL_H__

#define MAX_LEVEL_WIDTH                     40
#define MAX_LEVEL_HEIGHT                    40

#define viewport							((volatile struct VectorINT16 *)0xE80018) // GVRAM layer 0 position

#include "misc.h"
#include "GameObject.h"

typedef struct Box Box;
typedef struct LevelFileData LevelFileData;
typedef struct Level Level;

struct Box
{
    short x;
    short y;
    short width;
    short height;
} __attribute__ ((packed));

struct LevelFileData
{
    short offsetLevelGameObjects;
    short offsetLevelGeometry;
} __attribute__ ((packed));

struct Level
{
    byte geometry[MAX_LEVEL_HEIGHT][MAX_LEVEL_WIDTH];
    byte objects[MAX_LEVEL_HEIGHT][MAX_LEVEL_WIDTH];
} level;

VectorINT16 renderPoint;

int IsOnSolidSurface(SpawnedGameObject *obj);
void LoadLevel(short levelNumber);
void PerformObjectLevelCollision();
void CollideObjectLevelSolid(SpawnedGameObject *obj, short lx, short ly);
#endif
